Package htsjdk.tribble

# Class TabixFeatureReader<T extends Feature,SOURCE>

java.lang.Object
htsjdk.tribble.AbstractFeatureReader<T,SOURCE>
htsjdk.tribble.TabixFeatureReader<T,SOURCE>

All Implemented Interfaces:
  `FeatureReader<T>`, `Closeable`, `AutoCloseable`

public class TabixFeatureReader<T extends Feature,SOURCE> extends AbstractFeatureReader<T,SOURCE>

Since:
  2/11/12

## Nested Class Summary

## Nested classes/interfaces inherited from class htsjdk.tribble.AbstractFeatureReader

`AbstractFeatureReader.ComponentMethods`

## Field Summary

### Fields inherited from class htsjdk.tribble.AbstractFeatureReader

`BLOCK_COMPRESSED_EXTENSIONS, codec, header`

## Constructor Summary

Constructors
Constructor
Description
`TabixFeatureReader(String featureFile, AsciiFeatureCodec codec)`
`TabixFeatureReader(String featureFile, String indexFile, AsciiFeatureCodec codec)`
`TabixFeatureReader(String featureFile, String indexFile, AsciiFeatureCodec codec, Function<SeekableByteChannel,SeekableByteChannel> wrapper, Function<SeekableByteChannel,SeekableByteChannel> indexWrapper)`

## Method Summary

Modifier and Type
Method
Description
`void`
`close()`
Closes the reader
`List<String>`
`getSequenceNames()`
Provides the list of sequenceNames if known.
`boolean`
`hasIndex()`
Whether the reader has an index or not Default implementation returns false
`CloseableTribbleIterator<T>`
`iterator()`
Provides access to all the features in the reader
`CloseableTribbleIterator<T>`
`query(String chr, int start, int end)`
Return iterator over all features overlapping the given interval

### Methods inherited from class htsjdk.tribble.AbstractFeatureReader

`getFeatureReader, getFeatureReader, getFeatureReader, getFeatureReader, getFeatureReader, getHeader, hasBlockCompressedExtension, hasBlockCompressedExtension, hasBlockCompressedExtension, isQueryable, isTabix, setComponentMethods`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface htsjdk.tribble.FeatureReader

`query`

## Constructor Details

### TabixFeatureReader

public TabixFeatureReader(String featureFile, AsciiFeatureCodec codec) throws IOException

Parameters:
  `featureFile` - - path to a feature file. Can be a local file, http url, or ftp url
  `codec` -
Throws:
  `IOException`

### TabixFeatureReader

public TabixFeatureReader(String featureFile, String indexFile, AsciiFeatureCodec codec) throws IOException

Parameters:
  `featureFile` - - path to a feature file. Can be a local file, http url, or ftp url
  `indexFile` - - path to the index file.
  `codec` -
Throws:
  `IOException`

### TabixFeatureReader

public TabixFeatureReader(String featureFile, String indexFile, AsciiFeatureCodec codec, Function<SeekableByteChannel,SeekableByteChannel> wrapper, Function<SeekableByteChannel,SeekableByteChannel> indexWrapper) throws IOException

Parameters:
  `featureFile` - path to a feature file. Can be a local file, http url, or ftp url
  `indexFile` - path to the index file.
  `wrapper` - a wrapper to apply to the byte stream from the featureResource allowing injecting features like caching and prefetching of the stream, may be null, will only be applied if featureFile is a uri representing a `Path`
  `indexWrapper` - a wrapper to apply to the byte stream from the indexResource, may be null, will only be applied if indexFile is a uri representing a `Path`
Throws:
  `IOException`

## Method Details

### hasIndex

public boolean hasIndex()
Description copied from class: `AbstractFeatureReader`
Whether the reader has an index or not Default implementation returns false

Overrides:
  `hasIndex` in class `AbstractFeatureReader<T extends Feature,SOURCE>`
Returns:
  false

### getSequenceNames

public List<String> getSequenceNames()
Description copied from interface: `FeatureReader`
Provides the list of sequenceNames if known. Otherwise will return an empty list.

Returns:
  the list of sequenceNames if known. Otherwise will return an empty list.

### query

public CloseableTribbleIterator<T> query(String chr, int start, int end) throws IOException
Return iterator over all features overlapping the given interval

Parameters:
  `chr` -
  `start` -
  `end` -
Returns:
Throws:
  `IOException`

### iterator

public CloseableTribbleIterator<T> iterator() throws IOException
Description copied from interface: `FeatureReader`
Provides access to all the features in the reader

Returns:
  an iterator to all the features in the reader
Throws:
  `IOException` - If there's a problem reading.

### close

public void close() throws IOException
Description copied from interface: `FeatureReader`
Closes the reader

Throws:
  `IOException`